//BLE_Nano33.ino 29/08/2024 20:23:00

#include <ArduinoBLE.h>

//----------------------------------------------------------------------------------------------------------------------
// BLE UUIDs
//----------------------------------------------------------------------------------------------------------------------
#define BLE_UUID_TEST_SERVICE "4fafc201-1fb5-459e-8fcc-c5c9c331914b"
#define BLE_UUID_ACCELERATION "beb5483e-36e1-4688-b7f5-ea07361b26a8"
//----------------------------------------------------------------------------------------------------------------------
// BLE
//----------------------------------------------------------------------------------------------------------------------
BLEService testService(BLE_UUID_TEST_SERVICE);
BLEIntCharacteristic accelerationCharacteristic("BLE_UUID_ACCELERATION", BLERead | BLENotify);

//vars
unsigned long lgUpdateTime;
int accelerationX = 0;

bool setupBleMode()
{
     if (!BLE.begin())
     {
               return false;
     }
     
     // set advertised local name and service UUID:
     //BLE.setDeviceName("Nano33");
     BLE.setLocalName("Nano33");
     BLE.setAdvertisedService(testService);
     // BLE add characteristics
     testService.addCharacteristic(accelerationCharacteristic);
     // add service
     BLE.addService(testService);
     // set the initial value for the characeristic:
     accelerationCharacteristic.writeValue(0);
     // start advertising
     BLE.advertise();
     return true;
}

void setup()
{
         Serial.begin(9600);
         lgUpdateTime = millis();
         //while (!Serial);
         setupBleMode();
}

void loop()
{
        // listen for BLE peripherals to connect:
        BLEDevice central = BLE.central();
        
        if (central)
        {
                Serial.print("Connected to central: ");
                Serial.println(central.address());
                
                while (central.connected())
                {
                      //Excute loop every 10 seconds
	                  if((millis() - lgUpdateTime) > 10000) 
                      {
                             lgUpdateTime = millis();
                             accelerationCharacteristic.writeValue(accelerationX);
                             accelerationX++;
                             Serial.println(accelerationX);
                      }
                
                } // while connected
                
                Serial.print(F("Disconnected from central: "));
                Serial.println(central.address());
        
        } // if central
} // loop